gtkmm: Gtk::SortListModel Class Reference

gtkmm 4.22.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::SortListModel Class Reference
ListView Classes

A list model that sorts its items. More...

`#include <gtkmm/sortlistmodel.h>`

Inheritance diagram for Gtk::SortListModel:
[legend]

## Public Member Functions
| SortListModel (SortListModel &&src) noexcept
SortListModel & | operator= (SortListModel &&src) noexcept
| ~SortListModel () noexcept override
GtkSortListModel * | gobj ()
| Provides access to the underlying C GObject.
const GtkSortListModel * | gobj () const
| Provides access to the underlying C GObject.
GtkSortListModel * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_sorter (const Glib::RefPtr< Sorter > &sorter)
| Sets a new sorter on self.
Glib::RefPtr< Sorter > | get_sorter ()
| Gets the sorter that is used to sort self.
Glib::RefPtr< const Sorter > | get_sorter () const
| Gets the sorter that is used to sort self.
void | set_section_sorter (const Glib::RefPtr< Sorter > &sorter)
| Sets a new section sorter on self.
Glib::RefPtr< Sorter > | get_section_sorter ()
| Gets the section sorter that is used to sort items of self into sections.
Glib::RefPtr< const Sorter > | get_section_sorter () const
| Gets the section sorter that is used to sort items of self into sections.
void | set_model (const Glib::RefPtr< Gio::ListModel > &model)
| Sets the model to be sorted.
Glib::RefPtr< Gio::ListModel > | get_model ()
| Gets the model currently sorted or `nullptr` if none.
Glib::RefPtr< const Gio::ListModel > | get_model () const
| Gets the model currently sorted or `nullptr` if none.
void | set_incremental (bool incremental=true)
| Sets the sort model to do an incremental sort.
bool | get_incremental () const
| Returns whether incremental sorting is enabled.
guint | get_pending () const
| Estimates progress of an ongoing sorting operation.
Glib::PropertyProxy< bool > | property_incremental ()
| If the model should sort items incrementally.
Glib::PropertyProxy_ReadOnly< bool > | property_incremental () const
| If the model should sort items incrementally.
Glib::PropertyProxy_ReadOnly< GType > | property_item_type () const
| The type of items.
Glib::PropertyProxy< Glib::RefPtr< Gio::ListModel > > | property_model ()
| The model being sorted.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::ListModel > > | property_model () const
| The model being sorted.
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_items () const
| The number of items.
Glib::PropertyProxy_ReadOnly< guint > | property_pending () const
| Estimate of unsorted items remaining.
Glib::PropertyProxy< Glib::RefPtr< Sorter > > | property_sorter ()
| The sorter for this model.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Sorter > > | property_sorter () const
| The sorter for this model.
Glib::PropertyProxy< Glib::RefPtr< Sorter > > | property_section_sorter ()
| The section sorter for this model, if one is set.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Sorter > > | property_section_sorter () const
| The section sorter for this model, if one is set.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::ListModel
| ListModel (ListModel &&src) noexcept
ListModel & | operator= (ListModel &&src) noexcept
| ~ListModel () noexcept override
GListModel * | gobj ()
const GListModel * | gobj () const
GType | get_item_type () const
guint | get_n_items () const
Glib::RefPtr< Glib::ObjectBase > | get_object (guint position)
Glib::RefPtr< const Glib::ObjectBase > | get_object (guint position) const
Glib::RefPtr< T_item > | get_typed_object (guint position)
Glib::RefPtr< const T_item > | get_typed_object (guint position) const
Glib::SignalProxy< void(guint, guint, guint)> | signal_items_changed ()
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< SortListModel > | create (const Glib::RefPtr< Gio::ListModel > &model, const Glib::RefPtr< Sorter > &sorter)
Static Public Member Functions inherited from Gio::ListModel
static void | add_interface (GType gtype_implementer)
static GType | get_type ()

## Protected Member Functions
| SortListModel (const Glib::RefPtr< Gio::ListModel > &model, const Glib::RefPtr< Sorter > &sorter)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gio::ListModel
| ListModel ()
void | items_changed (guint position, guint removed, guint added)
virtual GType | get_item_type_vfunc ()
virtual guint | get_n_items_vfunc ()
virtual gpointer | get_item_vfunc (guint position)
Glib::RefPtr< Gio::ListModel > | wrap (GListModel *object, bool take_copy=false)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::SortListModel > | wrap (GtkSortListModel *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A list model that sorts its items.

Gtk::SortListModel is a list model that takes a list model and sorts its elements according to a Gtk::Sorter.

The model can be set up to do incremental sorting, so that sorting long lists doesn't block the UI. See set_incremental() for details.

Gtk::SortListModel is a generic model and because of that it cannot take advantage of any external knowledge when sorting. If you run into performance issues with Gtk::SortListModel, it is strongly recommended that you write your own sorting list model.

See also
  Gio::ListModel, Gtk::Sorter

Since gtkmm 3.98:

## Constructor & Destructor Documentation

## ◆ SortListModel() [1/2]

Gtk::SortListModel::SortListModel | ( | SortListModel && | src | ) |
| noexcept

## ◆ ~SortListModel()

Gtk::SortListModel::~SortListModel | ( |  | ) |
| overridenoexcept

## ◆ SortListModel() [2/2]

Gtk::SortListModel::SortListModel | ( | const Glib::RefPtr< Gio::ListModel > & | model,
|  | const Glib::RefPtr< Sorter > & | sorter
| ) |  |
| explicitprotected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< SortListModel > Gtk::SortListModel::create | ( | const Glib::RefPtr< Gio::ListModel > & | model,
|  | const Glib::RefPtr< Sorter > & | sorter
| ) |  |
| static

## ◆ get_incremental()

bool Gtk::SortListModel::get_incremental | ( |  | ) | const

Returns whether incremental sorting is enabled.

See set_incremental().

Returns
  `true` if incremental sorting is enabled.

## ◆ get_model() [1/2]

Glib::RefPtr< Gio::ListModel > Gtk::SortListModel::get_model | ( |  | ) |

Gets the model currently sorted or `nullptr` if none.

Returns
  The model that gets sorted.

## ◆ get_model() [2/2]

Glib::RefPtr< const Gio::ListModel > Gtk::SortListModel::get_model | ( |  | ) | const

Gets the model currently sorted or `nullptr` if none.

Returns
  The model that gets sorted.

## ◆ get_pending()

guint Gtk::SortListModel::get_pending | ( |  | ) | const

Estimates progress of an ongoing sorting operation.

The estimate is the number of items that would still need to be sorted to finish the sorting operation if this was a linear algorithm. So this number is not related to how many items are already correctly sorted.

If you want to estimate the progress, you can use code like this:

[C example ellipted]

If no sort operation is ongoing - in particular when property_incremental() is `false` - this function returns 0.

Returns
  A progress estimate of remaining items to sort.

## ◆ get_section_sorter() [1/2]

Glib::RefPtr< Sorter > Gtk::SortListModel::get_section_sorter | ( |  | ) |

Gets the section sorter that is used to sort items of self into sections.

Since gtkmm 4.12:

Returns
  The sorter of self.

## ◆ get_section_sorter() [2/2]

Glib::RefPtr< const Sorter > Gtk::SortListModel::get_section_sorter | ( |  | ) | const

Gets the section sorter that is used to sort items of self into sections.

Since gtkmm 4.12:

Returns
  The sorter of self.

## ◆ get_sorter() [1/2]

Glib::RefPtr< Sorter > Gtk::SortListModel::get_sorter | ( |  | ) |

Gets the sorter that is used to sort self.

Returns
  The sorter of self.

## ◆ get_sorter() [2/2]

Glib::RefPtr< const Sorter > Gtk::SortListModel::get_sorter | ( |  | ) | const

Gets the sorter that is used to sort self.

Returns
  The sorter of self.

## ◆ get_type()

static GType Gtk::SortListModel::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkSortListModel * Gtk::SortListModel::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkSortListModel * Gtk::SortListModel::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkSortListModel * Gtk::SortListModel::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

SortListModel & Gtk::SortListModel::operator= | ( | SortListModel && | src | ) |
| noexcept

## ◆ property_incremental() [1/2]

Glib::PropertyProxy< bool > Gtk::SortListModel::property_incremental | ( |  | ) |

If the model should sort items incrementally.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_incremental() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::SortListModel::property_incremental | ( |  | ) | const

If the model should sort items incrementally.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_item_type()

Glib::PropertyProxy_ReadOnly< GType > Gtk::SortListModel::property_item_type | ( |  | ) | const

The type of items.

See Gio::ListModel::get_item_type().

Since gtkmm 4.8:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Gio::ListModel > > Gtk::SortListModel::property_model | ( |  | ) |

The model being sorted.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_model() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::ListModel > > Gtk::SortListModel::property_model | ( |  | ) | const

The model being sorted.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_n_items()

Glib::PropertyProxy_ReadOnly< unsigned int > Gtk::SortListModel::property_n_items | ( |  | ) | const

The number of items.

See Gio::ListModel::get_n_items().

Since gtkmm 4.8:

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pending()

Glib::PropertyProxy_ReadOnly< guint > Gtk::SortListModel::property_pending | ( |  | ) | const

Estimate of unsorted items remaining.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_section_sorter() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Sorter > > Gtk::SortListModel::property_section_sorter | ( |  | ) |

The section sorter for this model, if one is set.

Since gtkmm 4.12:

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_section_sorter() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Sorter > > Gtk::SortListModel::property_section_sorter | ( |  | ) | const

The section sorter for this model, if one is set.

Since gtkmm 4.12:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_sorter() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Sorter > > Gtk::SortListModel::property_sorter | ( |  | ) |

The sorter for this model.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_sorter() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Sorter > > Gtk::SortListModel::property_sorter | ( |  | ) | const

The sorter for this model.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_incremental()

void Gtk::SortListModel::set_incremental | ( | bool | incremental = `true` | ) |

Sets the sort model to do an incremental sort.

When incremental sorting is enabled, the `Gtk::SortListModel` will not do a complete sort immediately, but will instead queue an idle handler that incrementally sorts the items towards their correct position. This of course means that items do not instantly appear in the right place. It also means that the total sorting time is a lot slower.

When your filter blocks the UI while sorting, you might consider turning this on. Depending on your model and sorters, this may become interesting around 10,000 to 100,000 items.

By default, incremental sorting is disabled.

See get_pending() for progress information about an ongoing incremental sorting operation.

Parameters

  incremental | `true` to sort incrementally.

## ◆ set_model()

void Gtk::SortListModel::set_model | ( | const Glib::RefPtr< Gio::ListModel > & | model | ) |

Sets the model to be sorted.

The model's item type must conform to the item type of self.

Parameters

  model | The model to be sorted.

## ◆ set_section_sorter()

void Gtk::SortListModel::set_section_sorter | ( | const Glib::RefPtr< Sorter > & | sorter | ) |

Sets a new section sorter on self.

Since gtkmm 4.12:

Parameters

  sorter | The `Gtk::Sorter` to sort model with.

## ◆ set_sorter()

void Gtk::SortListModel::set_sorter | ( | const Glib::RefPtr< Sorter > & | sorter | ) |

Sets a new sorter on self.

Parameters

  sorter | The `Gtk::Sorter` to sort model with.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::SortListModel > wrap | ( | GtkSortListModel * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.